<?php

/**
 * Class Conseil
 */
class Conseil extends Model{

    protected $table = 'conseil';

    const NON_TRAITE = 1;
    const TRAITEMENT_EN_COURS = 2;
    const TRAITE = 3;

    /**
     * @param array $formvars
     * @throws DediException
     */
    public function add(array $formvars)
    {
        //add default params
        $formvars['conseil_statut_id'] = self::NON_TRAITE;
        $formvars['conseil_date_ajout'] = date('Y-m-d');
        $formvars['conseil_date_modif'] = date('Y-m-d');
        $formvars['boutique_id'] = Boutique::getInstance()->id;

        $this->save($formvars);
    }
}