<!--product/product_abstract-->

<article class="product {block name="producttype"}{/block}">
    {block name="productlabelsimg"}
        {if !empty($produit.promo)}
            <span class="labelTag promo">Promo</span>
        {/if}
    {/block}

    {*Button Delete*}
    {block name="productbtndelete"}
    {/block}

    <div class="productImage">
        {if $produit.prod_qte <= 0}
            <div class="labelNoStock">
                <div class="inner">
                    <span>{txt value="Victime de son succès !" key="bandeau_hors_stock_texte"}</span>
                </div>
            </div>
        {/if}
        {*main image*}
        {*{$p|dump}*}
        <a href="{url page="produit" produit_nom=$produit.produit_nom_nom id=$produit.produit_id}">
            {block name="image"}
                {image src=$produit.produit_image|default:"" width="280" height="280" alt=$produit.produit_image_nom|default:"" class="img-responsive"}
            {/block}
        </a>
        {* // main image*}
    </div>
    {*Title and desc*}
    <div class="productInfo">
        {block name="brand"}
            <a href="{url page="marque" marque_nom=$produit.marque_nom marque_id=$produit.marque_id}">
            <p class="productBrand">
                {$produit.marque_nom|truncate:40}&nbsp;
            </p>
            </a>
        {/block}
        {block name="title"}
                <a href="{url page="produit" produit_nom=$produit.produit_nom_nom id=$produit.produit_id}">
                <h2 class="productTitle">
                    {if !empty($slider) && $slider}
                        {device type="desktop"}
                            {$produit.produit_nom_nom|truncate:45}
                        {/device}
                        {device type="tablet"}
                            {$produit.produit_nom_nom|truncate:40}
                        {/device}
                        {device type="mobile"}
                            {$produit.produit_nom_nom|truncate:40}
                        {/device}
                    {else}
                        {device type="desktop"}
                            {$produit.produit_nom_nom|truncate:80}
                        {/device}
                        {device type="tablet"}
                            {$produit.produit_nom_nom|truncate:60}
                        {/device}
                        {device type="mobile"}
                            {$produit.produit_nom_nom|truncate:35}
                        {/device}
                    {/if}
                </h2>
            </a>
        {/block}

        {block name="productdesc"}{/block}

        {block name="productpublicprice"}
            <div class="productPrice">
                <p class="current {if !empty($produit.promo)}promo{/if}">{price ttc=$produit.produit_prix_ttc ht=$produit.produit_prix_ht}</p>

                {if !empty($produit.promo)}
                    <p class="old">{price ttc=$produit.prix_ttc ht=$produit.prix_ht}</p>
                    <p class="percent">-{$produit.promo_percent}%</p>
                {/if}
            </div>
        {/block}
    </div>
    {*Price and CTAs*}
    {block name="productactions"}
    {/block}
    {*</form>*}
    <div class="clear"></div>
</article>
