<?php
header("Content-Type: text/html; charset=UTF-8");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");
session_start();

if(empty($_SESSION['connexion']['administrateur_id'])) {header("Location: /back/");exit;}

include(dirname(__FILE__) . "/../../includes/config.inc.php");

// Synthaxe de sortie : MESSAGE|URL_REDIRECTION

if (!$_POST && empty($_GET['type'])) die;

$arrSousModuleBlock = array(

);

$nbPopup = mb_substr_count($_SERVER['REQUEST_URI'], 'div=ajax_pop');

if (!isset($_POST['back_id'])) $_POST['back_id'] = 0;
$id = $_POST['back_id'];
$class = getClassNameModule($_GET['module_page']);


$obj = new $class($_GET);

$isPopup = $nbPopup > 0;
if (!$id && $_GET['type'] == 'create') {

    if (empty($obj->droits['ADD'])) {
        header("HTTP/1.0 400");
        exit;
    }

    $id = $obj->create($_POST);

    if (!$id) {

        $out = "Erreur(s) lors de la cr&eacute;ation<br/>Si le probl&egrave;me persiste, contactez votre administrateur|";
        header("HTTP/1.0 400");

    } else {

        $out = "Modification effectu&eacute;e avec succ&egrave;s";
        header("HTTP/1.0 201");

        if ($_POST['back_type'] == 'cmd_back') {
            $out .= '|' . html_entity_decode($obj->link_to('searchList'));
        } elseif ($_POST['back_type'] == 'cmd_stay') {
            if ($isPopup) {
                $blockId = (!empty($_POST['back_id'])) ? $_POST['back_id'] : (!empty($_GET['back_id']) ? $_GET['back_id'] : $id);
                $out .= '|_RELOADSOUSMODULEBLOCK_|' . $blockId . '|' . $obj->name_url . '|' . html_entity_decode($obj->link_to('searchList'));
            } else {
                $out .= '|' . html_entity_decode($obj->link_to('modForm', array('id' => $id)));
            }
        } elseif ($_POST['back_type'] == 'cmd_new') {
            $out .= '|' . html_entity_decode($obj->link_to('addForm'));
        } elseif ($_POST['back_type'] == 'cmd_save_back') {
            if ($isPopup) {
                $blockId = (!empty($_POST['block_id'])) ? $_POST['block_id'] : $_GET['block_id'];
                $out .= '|_RELOADSOUSMODULEBLOCK_|' . $blockId . '|' . $obj->name_url . '|' . html_entity_decode($obj->link_to('searchList'));
            } else {
                $out .= '|_RELOAD_|' . $obj->name_url . '|' . html_entity_decode($obj->link_to('searchList'));
            }
        }
    }
} elseif ($id && $_GET['type'] == 'create' && $_GET['type'] != 'delete') {

    if ($_POST['back_type'] == 'cmd_duplicate') {

        if (empty($obj->droits['DUP'])) {
            header("HTTP/1.0 400");
            exit;
        }

        $custom = $obj->duplicate($_POST);
        $func   = explode('|', $custom);

        $out = "Duplication effectu&eacute;e avec succ&egrave;s";
        header("HTTP/1.0 201");

        $out .= '|' . html_entity_decode($obj->link_to('searchList'));

    } else {

        if (empty($obj->droits['MOD'])) {
            header("HTTP/1.0 400");
            exit;
        }

        try {
            $obj->update($_POST);
        } catch (Exception $e) {
            echo $e->getMessage();
            header("HTTP/1.0 400");
            exit;
        }

        $out = "Modification effectu&eacute;e avec succ&egrave;s";
        header("HTTP/1.0 201");



        if ($_POST['back_type'] == 'cmd_back') {
            $out .= '|' . html_entity_decode($obj->link_to('searchList'));
        } elseif ($_POST['back_type'] == 'cmd_save_back') {
            $out .= '|_RELOAD_|' . $obj->name_url . '|' . html_entity_decode($obj->link_to('searchList'));
        } elseif ($_POST['back_type'] == 'cmd_stay') {
            if ($isPopup) {
                $out .= '|_RELOADSOUSMODULEBLOCK_|' . $_POST['back_id'] . '|' . $obj->name_url . '|' . html_entity_decode($obj->link_to('searchList'));
            } else {
                $out .= '|' . html_entity_decode($obj->link_to('modForm', array('id' => $id)));
            }
        }
    }

} elseif ($_POST['id'] && $_GET['type'] == 'delete') {

    $_POST['back_id'] = $_POST['id'];

    if (empty($obj->droits['DEL'])) {
        header("HTTP/1.0 400");
        exit;
    }

    if ($obj->delete($_POST)) {

        $out = "Enregistrement supprim&eacute; avec succ&egrave;s";
        header("HTTP/1.0 201");

        if ($_GET['div'] && empty($_POST['div'])) $_POST['div'] = $_GET['div'];

        if ($_POST['div']) {
            $out .= '|' . $_POST['div'];
            if (isset($_GET['refresh'])) {
                $out .= '|' . $_GET['refresh'] . '|' . html_entity_decode($obj->link_to('searchList'));
            }
        } else {
            $out .= '|' . html_entity_decode($obj->link_to('searchList'));
        }
    } else {
        //KO
        $out = "Erreur(s) lors de la suppr&eacute;ssion<br/>Si le probl&egrave;me persiste, contactez votre administrateur|";
        header("HTTP/1.0 400");
    }
} else {
    //KO
    $out = "JS Error #1|";
    header("HTTP/1.0 400");
}
echo $out;
exit;
