{assign var="template" value="Footer"}
{include file="parts/reinsurance.tpl"}

<!-- parts/footer.tpl -->

<footer>

    <div class="wrapFooterTop">
        <div class="container">
            <div class="row">
                <div class="col-sm-3">
                    <h2>Mon site</h2>
                    <ul class="list-unstyled">
                        <li><a href="{url page="compte"}">Mon compte</a></li>
                        <li><a href="{url page="contact"}">Contactez-nous</a></li>
                    </ul>
                </div>
                {foreach from=$arrFooter item=col}
                    <div class="col-sm-3">
                        <h2>{$col.menu_nom_nom}</h2>
                        <ul class="list-unstyled">
                            {foreach from=$col.pages item=$page}
                                <li><a href="{url page="page" page_nom_url=$page.page_nom_url}">{$page.page_nom_nom}</a></li>
                            {/foreach}
                        </ul>
                    </div>
                {/foreach}
                <div class="col-sm-3">
                    <h2>Suivez-nous</h2>
                    <ul class="list-unstyled">
                        {if !empty($config_social.facebook)}
                            <li><a href="{$config_social.facebook}">Facebook</a></li>
                        {/if}
                        {if !empty($config_social.twitter)}
                            <li><a href="{$config_social.twitter}">Twitter</a></li>
                        {/if}
                    </ul>
                </div>
                <div class="col-sm-3">
                    <h2>Newsletter</h2>
                    <form action="#" class="form-inline wrapFloatLabel">
                        <input type="text" id="txtNewsletter" class="floatLabelInput">
                        <label for="txtNewsletter" class="floatLabel"><span class="floatLabelContent">Votre email...</span></label>
                        <button type="submit" data-toggle="modal" data-target=".popupNewsletter">OK</button>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <div class="wrapFooterBottom">
        <div class="container">
            <div class="col-xs-12">
                <div>
                    <a href="{url page="sitemap"}">{txt value='Plan du site'}</a> <span>|</span>
                    {txt value="© 2019 Nom de la boutique - Tous droits réservés" key="footer_link_copyright"} <span>|</span>
                    <a href="https://www.dedi-agency.com/" target="_blank">Designed with love by Dedi, solution e-commerce</a>
                </div>
            </div>
        </div>
    </div>

</footer>